import numpy

def polygonLength(pointSet):
	return numpy.abs(numpy.roll(numpy.array(pointSet), -1) - numpy.array(pointSet)).sum().item()

def parametrizeByArcLength(pointSet, step = 5.0):
	lengthSet = numpy.abs(numpy.roll(numpy.array(pointSet), -1) - numpy.array(pointSet))
	sumSet = numpy.cumsum(lengthSet)

	length = sumSet[-1].real
	points = int(numpy.ceil(length / step).item())
	n = len(pointSet)

	step = length / points
	resultSet = numpy.zeros(points, dtype=complex)
	
	j = 0
	for i in range(0, points):
		u = i * step
		while u > sumSet[j]:
			j += 1
		t = (sumSet[j] - u) / lengthSet[j]
		point = (1 - t) * pointSet[(j + 1) % n] + t * pointSet[j]
		resultSet[i] = point

	return resultSet
